extern int strlen alias _astrlen(string *src);
extern int strcpy alias _astrcpy(string *dest,string *src);
extern int strcat alias _astrcat(string *dest,string *src);

struct GUID
{
	int x[4];
}
struct CLSID
{
	int x[4];
}
struct IID
{
	int x[4];
}
// general
#typedef COLORREF     unsigned int
#typedef PVOID        pointer
#typedef LPVOID       pointer
#typedef UINT         unsigned int
#typedef WINOLEAPI    unsigned int
#typedef DWORD        unsigned int
#typedef LRESULT      unsigned int
#typedef CLIPFORMAT   unsigned int
#typedef UINT_PTR     unsigned int
#typedef LONG         int
#typedef ULONG        unsigned int
#typedef ULONGLONG    unsigned int64
#typedef LONGLONG     int64
#typedef SHORT        word
#typedef CHAR         byte
#typedef USHORT       unsigned word
#typedef BOOL         int
#typedef ATOM         word
#typedef WPARAM       unsigned int
#typedef LPARAM       unsigned int
#typedef HINSTANCE    unsigned int
// handles
#typedef HLOCAL        unsigned int
#typedef HRGN          unsigned int
#typedef HDC           unsigned int
#typedef HWND          unsigned int
#typedef HACCEL        unsigned int
#typedef HMENU         unsigned int
#typedef HOLEMENU      unsigned int
#typedef HBITMAP       unsigned int
#typedef HMETAFILEPICT unsigned int
#typedef HENHMETAFILE  unsigned int
#typedef HGLOBAL       unsigned int
#typedef HICON         unsigned int
#typedef HCURSOR       unsigned int
#typedef HANDLE        unsigned int
#typedef HBRUSH        unsigned int
#typedef HGDIOBJ       unsigned int
// strings
#typedef WCHAR         unsigned word
#typedef LPTSTR        string
#typedef LPSTR         string
#typedef LPWSTR        string
#typedef LPOLESTR      string
#typedef LPCTSTR       string
#typedef LPCOLESTR     string
#typedef OLECHAR       string

#define MAX_PATH 260

struct BITMAP
{
  LONG   bmType;
  LONG   bmWidth;
  LONG   bmHeight;
  LONG   bmWidthBytes;
  WORD   bmPlanes;
  WORD   bmBitsPixel;
  LPVOID *bmBits;
}

struct CREATESTRUCT
{
    LPVOID lpCreateParams;
    HINSTANCE hInstance;
    HMENU hMenu;
    HWND hwndParent;
    int cy;
    int cx;
    int y;
    int x;
    LONG style;
    LPCTSTR *lpszName;
    LPCTSTR *lpszClass;
    DWORD dwExStyle;
}

struct WNDCLASS
{
	UINT style;
	UINT lpfnwndproc;
	int cbClsextra;
	int  cbWndExtra;
	HINSTANCE  hInstance;
	HICON hIcon;
	HCURSOR hCursor;
	HBRUSH hbrBackground;
	string *lpszMenuName;
	string *lpszClassName;
}
struct OLEINPLACEFRAMEINFO
{ 
    UINT   cb; 
    BOOL   fMDIApp; 
    HWND   hwndFrame; 
    HACCEL haccel; 
    UINT   cAccelEntries; 
} 
struct MENUITEMINFO
{
  UINT    cbSize;
  UINT    fMask;
  UINT    fType;
  UINT    fState;
  UINT    wID;
  UINT    hSubMenu;
  UINT    hbmpChecked;
  UINT    hbmpUnchecked;
// union
    DWORD   dwItemData [O];
    void    *pItemData [1];
  pointer dwTypeData;
  UINT    cch;
  UINT    hbmpItem;
}

struct SIZE
{
	UINT cx;
	UINT cy;
}
struct POINTL { 
  LONG x; 
  LONG y; 
}
struct POINTF 
{ 
    float x; 
    float y; 
}
struct POINTS // check it
{
  SHORT x; 
  SHORT y; 
}
struct SIZEL
{
	UINT cx;
	UINT cy;
}

struct MSG
{
    HWND hwnd;
    UINT message;
    WPARAM wParam;
    LPARAM lParam;
    DWORD time;
    POINT pt;
}
struct PAINTSTRUCT
{ 
  HDC  hdc;
  BOOL fErase;
  RECT rcPaint;
  BOOL fRestore;
  BOOL fIncUpdate;
  BYTE rgbReserved[32]; 
}
struct BITMAPINFOHEADER,2
{
  DWORD  biSize; 
  LONG   biWidth; 
  LONG   biHeight; 
  WORD   biPlanes; 
  WORD   biBitCount; 
  DWORD  biCompression; 
  DWORD  biSizeImage; 
  LONG   biXPelsPerMeter; 
  LONG   biYPelsPerMeter; 
  DWORD  biClrUsed; 
  DWORD  biClrImportant; 
}
// biCompression
#define BI_RGB       0
#define BI_RLE8      1
#define BI_RLE4      2
#define BI_BITFIELDS 3
#define BI_JPEG      4
#define BI_PNG       5

struct RGBQUAD,1
{
	unsigned byte rgbBlue;
	unsigned byte rgbGreen;
	unsigned byte rgbRed;
	unsigned byte rgbReserved;
}
struct BITMAPINFO
{
  BITMAPINFOHEADER bmiHeader; 
  RGBQUAD          bmiColors[1]; 
}
struct PREVENT_MEDIA_REMOVAL,1
{
  byte PreventMediaRemoval;
}
struct SECURITY_ATTRIBUTES
{
	DWORD   nLength;
	LPVOID *lpSecurityDescriptor;
	BOOL    bInheritHandle;
}
struct STARTUPINFO
{
	DWORD  cb;
	LPTSTR *lpReserved;
	LPTSTR *lpDesktop;
	LPTSTR *lpTitle;
	DWORD  dwX;
	DWORD  dwY;
	DWORD  dwXSize;
	DWORD  dwYSize;
	DWORD  dwXCountChars;
	DWORD  dwYCountChars;
	DWORD  dwFillAttribute;
	DWORD  dwFlags;
	word   wShowWindow;
	word   cbReserved2;
	byte  *lpReserved2;
	HANDLE hStdInput;
	HANDLE hStdOutput;
	HANDLE hStdError;
}
struct PROCESS_INFORMATION
{
	HANDLE hProcess;
	HANDLE hThread;
	DWORD dwProcessId;
	DWORD dwThreadId;
}

#define CS_GLOBALCLASS   0x4000
#define IDC_ARROW            32512
#define WM_DESTROY  2
#define WM_NCCREATE 0x81
#define WM_CREATE   1
#define WM_GETTEXT  0xD
#define WM_CLOSE    0x10
#define WM_SIZE     5
#define BLACK_BRUSH              4
#define INVALID_HANDLE_VALUE 0xFFFFFFFF

#define SM_CXSCREEN  0
#define SM_CYSCREEN  1
#define WS_OVERLAPPEDWINDOW  0xCF0000
#define WS_VISIBLE  0x10000000
#define CW_USEDEFAULT  0x80000000
#define SW_SHOW  5
#define WM_PAINT  0xF

#define LR_LOADFROMFILE  0x10
#define IMAGE_BITMAP  0
#define GWL_STYLE  -16
#define SWP_NOMOVE  2

extern _hinstance as HINSTANCE;

//import int IsEqualGUID(GUID *riid1, GUID *riid2); function in extras.src

// some crt cdecl imports
extern int printf(...);
extern int sprintf(string *destination,...);
extern int cdecl memset(void *destination,byte fill_with,int count);
extern int cdecl memcpy(void *destination,void *source,int size);
extern int cdecl memcmp(void *memory1,void *memory2,int size);
extern int fopen(...);
extern int fwrite(...);
extern int putc(...);
extern int fclose(...);
extern int system(...);
extern void cdecl malloc(int memsize);
extern int  cdecl free(void *memory);
extern void cdecl strstr(string *find_in, string *find_first_what);
extern void cdecl strrchr(string *find_in, byte find_last_what);
extern byte getch alias _getch();

import int lstrlenW(WCHAR *lpwsz);
import int lstrcpyW(WCHAR *dest, WCHAR *src);

declare import, LocalFree(HLOCAL hMem),HLOCAL;

declare import, GetSubMenu(HMENU hMenu, int nPos),HMENU;
declare import, AppendMenu alias AppendMenuA(HMENU hMenu, UINT uFlags, UINT_PTR uIDNewItem, LPCTSTR *lpNewItem),BOOL;
declare import, SetMenu(HWND hWnd, HMENU hMenu),BOOL;
declare import, RemoveMenu(HMENU hMenu, UINT uPosition, UINT uFlags),BOOL;
declare import, DrawMenuBar(HWND hWnd),BOOL;
declare import, SetWindowText alias SetWindowTextA(HWND hWnd, LPCTSTR *lpString),BOOL;
declare import, CopyRect(RECT *lprcDst, RECT *lprcSrc),BOOL;
declare import, GetClientRect(HWND hWnd, RECT *lpRect),BOOL;
declare import, GetMenu(HWND hWnd),HMENU;
declare import, AdjustWindowRect(RECT *lpRect, DWORD dwStyle, BOOL bMenu),BOOL;
declare import, RegisterClass alias RegisterClassA(WNDCLASS *lpWndClass),ATOM;
Declare import, LoadCursor alias LoadCursorA(HINSTANCE hInstance, LPCTSTR *lpCursorName),HCURSOR;
Declare import, DefWindowProc alias DefWindowProcA(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam),LRESULT;
Declare import, GetProp alias GetPropA(HWND hwnd, LPCTSTR *lpString),HANDLE;
Declare import, RemoveProp alias RemovePropA(HWND hwnd, LPCTSTR *lpString),HANDLE;
Declare import, SetProp alias SetPropA(HWND hwnd, LPCTSTR *lpString, void hData),BOOL;
Declare import, GetStockObject(int fnObject),HGDIOBJ;
declare import, IsWindowVisible(HWND hwnd),BOOL;
declare import, CreateCompatibleDC(HDC hdc),HDC;
declare import, CreateCompatibleBitmap(HDC hdc,int nWidth,int nHeight),HBITMAP;
declare import, GetSystemMetrics(int nIndex),int;
declare import, SelectObject(HDC hdc, HGDIOBJ hgdiobj),HGDIOBJ;
declare import, DeleteObject(HGDIOBJ hObject),BOOL;
declare import, DeleteDC(HDC hdc),BOOL;
declare import, GetCommandLine alias GetCommandLineA(),pointer;
declare import, PathGetArgs alias PathGetArgsA(LPCTSTR *pszPath),LPTSTR;
declare import, PathUnquoteSpaces alias PathUnquoteSpacesA(LPTSTR *lpsz);
declare import, GetDriveType alias GetDriveTypeA(LPCTSTR *lpRootPathName),UINT;
#define DRIVE_REMOVABLE  2
#define DRIVE_CDROM      5
declare import, MultiByteToWideChar(UINT CodePage, DWORD dwFlags,LPCSTR *lpMultiByteStr,int cbMultiByte,LPWSTR *lpWideCharStr,int cchWideChar),int;
declare import, CloseHandle(HANDLE hObject),BOOL;
import int Sleep(DWORD ms);
extern int wsprintf alias wsprintfA(...);
import int GetLastError();
declare import, EnumChildWindows(HWND hWndParent, void lpEnumFunc, LPARAM lParam),BOOL;
declare import, SendMessage alias SendMessageA(HWND hWnd,UINT Msg,WPARAM wParam,LPARAM lParam),LRESULT;
declare import, FindWindowEx alias FindWindowExA(HWND hwndParent,HWND hwndChildAfter,LPCTSTR *lpszClass,LPCTSTR *lpszWindow),HWND;
declare import, ShowWindow(HWND hWnd, int nCmdShow),BOOL;
declare import, UpdateWindow(HWND hWnd),BOOL;
declare import, GetDC(HWND hWnd),HDC;
declare import, ReleaseDC(HWND hWnd, HDC hdc),int;
declare import, DestroyWindow(HWND hWnd),BOOL;
declare import, BeginPaint(HWND hwnd, PAINTSTRUCT *lpPaint),HDC;
declare import, EndPaint(HWND hwnd, PAINTSTRUCT *lpPaint),BOOL;
declare import, GetObject alias GetObjectA(HGDIOBJ hgdiobj, int cbBuffer, LPVOID *lpvObject),int;
declare import, GetWindowRect(HWND hWnd,RECT *lpRect),BOOL;
declare import, GetWindowLong alias GetWindowLongA(HWND hWnd,int nIndex),LONG;
declare import, SetStretchBltMode(HDC hdc, int iStretchMode),int;
//iStretchMode
#define STRETCH_ANDSCANS    1
#define STRETCH_ORSCANS     2
#define STRETCH_DELETESCANS 3
#define STRETCH_HALFTONE    4
declare import, PaintDesktop(HDC hdc),BOOL;
declare import, GetPixel(HDC hdc, int nXPos, int nYPos),COLORREF;
declare import, WaitForSingleObject(HANDLE hHandle,DWORD dwMilliseconds),DWORD;
#define INFINITE       0xFFFFFFFF
#define WAIT_ABANDONED 0x00000080
#define WAIT_OBJECT_0  0x00000000
#define WAIT_TIMEOUT   0x00000102

declare import, LoadImage alias LoadImageA(
	HINSTANCE hinst,
    LPCTSTR *lpszName,
    UINT uType,
    int cxDesired,
    int cyDesired,
    UINT fuLoad),HANDLE;

declare import, SetWindowPos(HWND hWnd, HWND hWndInsertAfter, int X, int Y, int cx, int cy, UINT uFlags),BOOL;

declare import, CreateWindowEx alias CreateWindowExA(
    DWORD dwExStyle,
    LPCTSTR *lpClassName,
    LPCTSTR *lpWindowName,
    DWORD dwStyle,
    int x,
    int y,
    int nWidth,
    int nHeight,
    HWND hWndParent,
    HMENU hMenu,
    HINSTANCE hInstance,
    LPVOID lpParam
),HWND;

declare import, BitBlt(
  HDC hdcDest, // handle to destination DC
  int nXDest,  // x-coord of destination upper-left corner
  int nYDest,  // y-coord of destination upper-left corner
  int nWidth,  // width of destination rectangle
  int nHeight, // height of destination rectangle
  HDC hdcSrc,  // handle to source DC
  int nXSrc,   // x-coordinate of source upper-left corner
  int nYSrc,   // y-coordinate of source upper-left corner
  DWORD dwRop  // raster operation code
),BOOL;

declare import, StretchBlt(
  HDC hdcDest,      // handle to destination DC
  int nXOriginDest, // x-coord of destination upper-left corner
  int nYOriginDest, // y-coord of destination upper-left corner
  int nWidthDest,   // width of destination rectangle
  int nHeightDest,  // height of destination rectangle
  HDC hdcSrc,       // handle to source DC
  int nXOriginSrc,  // x-coord of source upper-left corner
  int nYOriginSrc,  // y-coord of source upper-left corner
  int nWidthSrc,    // width of source rectangle
  int nHeightSrc,   // height of source rectangle
  DWORD dwRop       // raster operation code
),BOOL;

#define SRCCOPY     0x00CC0020 //dwRop
#define SRCPAINT    0x00EE0086
#define SRCAND      0x008800C6
#define SRCINVERT   0x00660046
#define SRCERASE    0x00440328
#define NOTSRCCOPY  0x00330008
#define NOTSRCERASE 0x001100A6
#define MERGECOPY   0x00C000CA
#define MERGEPAINT  0x00BB0226
#define PATCOPY     0x00F00021
#define PATPAINT    0x00FB0A09
#define PATINVERT   0x005A0049
#define DSTINVERT   0x00550009
#define BLACKNESS   0x00000042
#define WHITENESS   0x00FF0062

declare import, PlgBlt(
  HDC hdcDest,          // handle to destination DC
  POINT *lpPoint,       // destination vertices
  HDC hdcSrc,           // handle to source DC
  int nXSrc,            // x-coord of source upper-left corner
  int nYSrc,            // y-coord of source upper-left corner
  int nWidth,           // width of source rectangle
  int nHeight,          // height of source rectangle
  opt HBITMAP hbmMask,  // handle to bitmask
  int xMask,            // x-coord of bitmask upper-left corner
  int yMask             // y-coord of bitmask upper-left corner
),BOOL;

declare import, GetDIBits(
  HDC hdc,           // handle to DC
  HBITMAP hbmp,      // handle to bitmap
  UINT uStartScan,   // first scan line to set
  UINT cScanLines,   // number of scan lines to copy
  VOID *lpvBits,     // array for bitmap bits
  BITMAPINFO *lpbi,  // bitmap data buffer
  UINT uUsage        // RGB or palette index
),int;
// uUsage
#define DIB_RGB_COLORS  0
#define DIB_PAL_COLORS  1

declare import, CreateFile alias CreateFileA(
  LPCTSTR *lpFileName,
  DWORD dwDesiredAccess,
  DWORD dwShareMode,
  SECURITY_ATTRIBUTES *lpSecurityAttributes,
  DWORD dwCreationDisposition,
  DWORD dwFlagsAndAttributes,
  HANDLE hTemplateFile
),HANDLE;
#define GENERIC_READ  0x80000000
#define GENERIC_WRITE  0x40000000
#define OPEN_EXISTING  3
#define FILE_SHARE_READ  0x1
#define FILE_SHARE_WRITE  0x2

declare import, DeviceIoControl(
  HANDLE hDevice,
  DWORD dwIoControlCode,
  LPVOID *lpInBuffer,
  DWORD nInBufferSize,
  VOID *lpOutBuffer,
  DWORD nOutBufferSize,
  DWORD *lpBytesReturned,
  OVERLAPPED *lpOverlapped
),BOOL;
#define IOCTL_STORAGE_MEDIA_REMOVAL  0x002D4804
#define IOCTL_STORAGE_EJECT_MEDIA  0x002D4808
#define FSCTL_LOCK_VOLUME  0x00090018
#define FSCTL_DISMOUNT_VOLUME  0x00090020

declare import, CreateProcess alias CreateProcessA(
  LPCTSTR *lpApplicationName,
  LPTSTR *lpCommandLine,
  SECURITY_ATTRIBUTES *lpProcessAttributes,
  SECURITY_ATTRIBUTES *lpThreadAttributes,
  BOOL bInheritHandles,
  DWORD dwCreationFlags,
  LPVOID *lpEnvironment,
  LPCTSTR *lpCurrentDirectory,
  STARTUPINFO *lpStartupInfo,
  PROCESS_INFORMATION *lpProcessInformation
),BOOL;

